Index: sansmodels/src/sans/models/c_models/DiamCyl.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/DiamCyl.cpp	(revision f9bf66165686c721c2f0b3a197f7dda1822721ad)
+++ sansmodels/src/sans/models/c_models/DiamCyl.cpp	(revision 770bab1b907c20488df256707ca66e7bc3eccb32)
@@ -88,41 +88,6 @@
  */
 double DiamCylFunc :: operator()(double qx, double qy) {
-	DiamCyldParameters dp;
-	// Fill parameter array
-	dp.radius     = radius();
-	dp.length     = length();
-
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_rad;
-	radius.get_weights(weights_rad);
-
-	// Get the dispersion points for the length
-	vector<WeightPoint> weights_len;
-	length.get_weights(weights_len);
-
-
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-
-	// Loop over radius weight points
-	for(int i=0; i<weights_rad.size(); i++) {
-		dp.radius = weights_rad[i].value;
-
-		// Loop over length weight points
-		for(int j=0; j<weights_len.size(); j++) {
-			dp.length = weights_len[j].value;
-			double _ptvalue = weights_rad[i].weight
-				* weights_len[j].weight
-				* DiamCyld_analytical_2DXY(&dp, qx, qy);
-			sum += _ptvalue;
-
-			norm += weights_rad[i].weight
-				* weights_len[j].weight;
-
-
-			}
-		}
-	return sum/norm;
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
 }
 
Index: sansmodels/src/sans/models/c_models/DiamEllip.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/DiamEllip.cpp	(revision f9bf66165686c721c2f0b3a197f7dda1822721ad)
+++ sansmodels/src/sans/models/c_models/DiamEllip.cpp	(revision 770bab1b907c20488df256707ca66e7bc3eccb32)
@@ -18,5 +18,4 @@
  *   sansmodels/src/libigor
  *
- *	TODO: refactor so that we pull in the old sansmodels.c_extensions
  */
 
@@ -87,42 +86,7 @@
  */
 double DiamEllipFunc :: operator()(double qx, double qy) {
-	DiamEllipsParameters dp;
-	// Fill parameter array
-	dp.radius_a      = radius_a();
-	dp.radius_b      = radius_b();
-
-	// Get the dispersion points for the radius a
-	vector<WeightPoint> weights_rad_a;
-	radius_a.get_weights(weights_rad_a);
-
-	// Get the dispersion points for the radius b
-	vector<WeightPoint> weights_rad_b;
-	radius_b.get_weights(weights_rad_b);
-
-
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-
-	// Loop over radius weight points
-	for(int i=0; i<weights_rad_a.size(); i++) {
-		dp.radius_a = weights_rad_a[i].value;
-		// Loop over length weight points
-		for(int j=0; j<weights_rad_b.size(); j++) {
-			dp.radius_b = weights_rad_b[j].value;
-
-			double _ptvalue = weights_rad_a[i].weight
-				*weights_rad_b[j].weight* DiamEllips_analytical_2DXY(&dp, qx, qy);
-			sum += _ptvalue;
-
-			norm += weights_rad_a[i].weight*weights_rad_b[j].weight;
-		}
-	}
-	// Averaging in theta needs an extra normalization
-	// factor to account for the sin(theta) term in the
-	// integration (see documentation).
-	return sum/norm;
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
 }
-
 /**
  * Function to evaluate 2D scattering function
Index: sansmodels/src/sans/models/c_models/Hardsphere.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/Hardsphere.cpp	(revision f9bf66165686c721c2f0b3a197f7dda1822721ad)
+++ sansmodels/src/sans/models/c_models/Hardsphere.cpp	(revision 770bab1b907c20488df256707ca66e7bc3eccb32)
@@ -79,31 +79,6 @@
  */
 double HardsphereStructure :: operator()(double qx, double qy) {
-	HardsphereParameters dp;
-	// Fill parameter array
-	dp.effect_radius      = effect_radius();
-	dp.volfraction = volfraction();
-
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_rad;
-	effect_radius.get_weights(weights_rad);
-
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-
-	// Loop over radius weight points
-	for(int i=0; i<weights_rad.size(); i++) {
-		dp.effect_radius = weights_rad[i].value;
-
-					double _ptvalue = weights_rad[i].weight
-						* Hardsphere_analytical_2DXY(&dp, qx, qy);
-					sum += _ptvalue;
-
-					norm += weights_rad[i].weight;
-	}
-	// Averaging in theta needs an extra normalization
-	// factor to account for the sin(theta) term in the
-	// integration (see documentation).
-	return sum/norm;
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
 }
 
Index: sansmodels/src/sans/models/c_models/HayterMSA.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/HayterMSA.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
+++ sansmodels/src/sans/models/c_models/HayterMSA.cpp	(revision 770bab1b907c20488df256707ca66e7bc3eccb32)
@@ -88,35 +88,6 @@
  */
 double HayterMSAStructure :: operator()(double qx, double qy) {
-	HayterMSAParameters dp;
-	// Fill parameter array
-	dp.effect_radius      = effect_radius();
-	dp.charge      = charge();
-	dp.volfraction = volfraction();
-	dp.temperature   = temperature();
-	dp.saltconc   = saltconc();
-	dp.dielectconst   = dielectconst();
-
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_rad;
-	effect_radius.get_weights(weights_rad);
-
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-
-	// Loop over radius weight points
-	for(int i=0; i<weights_rad.size(); i++) {
-		dp.effect_radius = weights_rad[i].value;
-
-		double _ptvalue = weights_rad[i].weight
-			* HayterMSA_analytical_2DXY(&dp, qx, qy);
-		sum += _ptvalue;
-
-		norm += weights_rad[i].weight;
-	}
-	// Averaging in theta needs an extra normalization
-	// factor to account for the sin(theta) term in the
-	// integration (see documentation).
-	return sum/norm;
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
 }
 
Index: sansmodels/src/sans/models/c_models/SquareWell.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/SquareWell.cpp	(revision f9bf66165686c721c2f0b3a197f7dda1822721ad)
+++ sansmodels/src/sans/models/c_models/SquareWell.cpp	(revision 770bab1b907c20488df256707ca66e7bc3eccb32)
@@ -83,33 +83,6 @@
  */
 double SquareWellStructure :: operator()(double qx, double qy) {
-	SquareWellParameters dp;
-	// Fill parameter array
-	dp.effect_radius      = effect_radius();
-	dp.volfraction = volfraction();
-	dp.welldepth   = welldepth();
-	dp.wellwidth   = wellwidth();
-
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_rad;
-	effect_radius.get_weights(weights_rad);
-
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-
-	// Loop over radius weight points
-	for(int i=0; i<weights_rad.size(); i++) {
-		dp.effect_radius = weights_rad[i].value;
-
-					double _ptvalue = weights_rad[i].weight
-						* SquareWell_analytical_2DXY(&dp, qx, qy);
-					sum += _ptvalue;
-
-					norm += weights_rad[i].weight;
-	}
-	// Averaging in theta needs an extra normalization
-	// factor to account for the sin(theta) term in the
-	// integration (see documentation).
-	return sum/norm;
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
 }
 
Index: sansmodels/src/sans/models/c_models/StickyHS.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/StickyHS.cpp	(revision f9bf66165686c721c2f0b3a197f7dda1822721ad)
+++ sansmodels/src/sans/models/c_models/StickyHS.cpp	(revision 770bab1b907c20488df256707ca66e7bc3eccb32)
@@ -85,33 +85,6 @@
  */
 double StickyHSStructure :: operator()(double qx, double qy) {
-	StickyHSParameters dp;
-	// Fill parameter array
-	dp.effect_radius      = effect_radius();
-	dp.volfraction = volfraction();
-	dp.perturb = perturb();
-	dp.stickiness = stickiness();
-
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_rad;
-	effect_radius.get_weights(weights_rad);
-
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-
-	// Loop over radius weight points
-	for(int i=0; i<weights_rad.size(); i++) {
-		dp.effect_radius = weights_rad[i].value;
-
-					double _ptvalue = weights_rad[i].weight
-						* StickyHS_analytical_2DXY(&dp, qx, qy);
-					sum += _ptvalue;
-
-					norm += weights_rad[i].weight;
-	}
-	// Averaging in theta needs an extra normalization
-	// factor to account for the sin(theta) term in the
-	// integration (see documentation).
-	return sum/norm;
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
 }
 
Index: sansmodels/src/sans/models/c_models/c_models.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/c_models.cpp	(revision 8dc02d8b4348f58c310e83b1e0b10a5ab1e56f16)
+++ sansmodels/src/sans/models/c_models/c_models.cpp	(revision 770bab1b907c20488df256707ca66e7bc3eccb32)
@@ -290,9 +290,9 @@
 	addCMultiShellModel(m);
 	addCBinaryHSModel(m);
-	addDisperser(m);
-	addCGaussian(m);
-	addCSchulz(m);
-	addCLogNormal(m);
-	addCLorentzian(m);
+	//addDisperser(m);
+	//addCGaussian(m);
+	//addCSchulz(m);
+	//addCLogNormal(m);
+	//addCLorentzian(m);
 	addCVesicleModel(m);
 	addCPoly_GaussCoil(m);
